"use strict";

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.SlicedReadStream = exports.FdSlicer = undefined;

var _bluebirdLst;

function _load_bluebirdLst() {
    return _bluebirdLst = _interopRequireDefault(require("bluebird-lst"));
}

var _events;

function _load_events() {
    return _events = require("events");
}

var _fs;

function _load_fs() {
    return _fs = _interopRequireWildcard(require("fs"));
}

var _fsExtraP;

function _load_fsExtraP() {
    return _fsExtraP = require("fs-extra-p");
}

var _stream;

function _load_stream() {
    return _stream = require("stream");
}

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

class FdSlicer extends (_events || _load_events()).EventEmitter {
    constructor(fd) {
        super();
        this.fd = fd;
    }
    read(buffer, offset, length, position, callback) {
        (_fs || _load_fs()).read(this.fd, buffer, offset, length, position, callback);
    }
    close() {
        const fd = this.fd;
        return fd == null ? (_bluebirdLst || _load_bluebirdLst()).default.resolve() : (0, (_fsExtraP || _load_fsExtraP()).close)(fd);
    }
}
exports.FdSlicer = FdSlicer;
class SlicedReadStream extends (_stream || _load_stream()).Readable {
    constructor(context, pos) {
        let end = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : -1;

        super();
        this.context = context;
        this.pos = pos;
        this.end = end;
        this.destroyed = false;
        this.destroyed = false;
    }
    _read(n) {
        if (this.destroyed) {
            return;
        }
        const toRead = Math.min(this._readableState.highWaterMark, n, this.end === -1 ? 0 : this.end - this.pos);
        if (toRead <= 0) {
            this.destroyed = true;
            this.push(null);
            return;
        }
        if (this.destroyed) {
            return;
        }
        const buffer = new Buffer(toRead);
        (_fs || _load_fs()).read(this.context.fd, buffer, 0, toRead, this.pos, (error, bytesRead) => {
            if (error != null) {
                this.destroy(error);
            } else if (bytesRead === 0) {
                this.destroyed = true;
                this.push(null);
            } else {
                this.pos += bytesRead;
                this.push(buffer.slice(0, bytesRead));
            }
        });
    }
    destroy(error) {
        if (this.destroyed) {
            return;
        }
        this.destroyed = true;
        this.emit("error", error);
    }
}
exports.SlicedReadStream = SlicedReadStream; //# sourceMappingURL=fdSlicer.js.map